Subject: [perpass] perens-perpass-appropriate-response-01

From: Bruce Perens <[email-masked]>
Date: Tue, 03 Dec 2013 17:25:40 -0800

I have written a reply to draft-farrell-perpass-attack-00

Please read it at http://perens.com/works/ietf/perpass/appropriate-response/01.pdf

The reply is _not_ in the form of an Internet Draft, because it's
political discourse.

Thanks

Bruce Perens

---

From: JOSEFSSON Erik <[email-masked]>
Date: Wed, 4 Dec 2013 05:08:38 +0000

Thanks!

//Erik

________________________________
From: perpass [[email-masked]] on behalf of Bruce Perens [[email-masked]]
Sent: Wednesday 4 December 2013 02:25
To: [email-masked]; [email-masked]; [email-masked]
Subject: [perpass] perens-perpass-appropriate-response-01

I have written a reply to draft-farrell-perpass-attack-00
Please read it at http://perens.com/works/ietf/perpass/appropriate-response/01.pdf
The reply is _not_ in the form of an Internet Draft, because it's political discourse.

    Thanks

    Bruce Perens

---

From: Martin Millnert <[email-masked]>
Date: Wed, 04 Dec 2013 11:07:20 +0100

Hi Bruce,

On Tue, 2013-12-03 at 17:25 -0800, Bruce Perens wrote:
> Please read it at
> http://perens.com/works/ietf/perpass/appropriate-response/01.pdf

The only technical argument that I found with any relevance and merit is
that proper encryption of every HTTP operation in HTTP2 would make
transparent proxying and caching without the end-users knowledge
impossible.  

I'd assume that has been discussed on HTTP-WG already, but in terms of
perpass, that is a feature/bug which is of much much lesser importance
than the dangers of pervasive surveillance.

HTTP2 with encryption will not make CDNs impossible, or even really
change them in any meaningful way since HTTP1/2 is merely the transport.
(CDN redirection is done using DNS or HTTP headers/payload.)
Nor will it make the enterprise with managed clients' content filtering
appliances impossible.
Uses, legitimate or not, of transparent proxy/caching will be hurt,
AFAIK, and that's the only technical issue worth debating IMHO.
Personally I'm ok with that.  Even so, there are ways to signal
existence of caching proxies which can be extended to cover some of
these areas, by moving to non-transparent proxying.

For the other, mostly technical, arguments put forth by you:

  p3. A sovereign entity may outlaw technical protocol X:
  It wouldn't be a sovereign entity if it couldn't.  It could outlaw Pi
= 3.1459... for all I care.  Point is we should not let a single
Sovereign Entity outlaw the correct definition of Pi, for the rest of
us. It is precisely within IETF's jurisdiction to define our global
common Internet communication protocols.  If a single backwards
Sovereign Entity held veto power over this we would be much poorer
today. Instead the backwards sovereign entities will have to live
without these protocols, which is what they in their sovereignty decided
anyway, so everybody would be happy...

  p3. Unnecessary to encrypt static content:
It has been quite clearly shown that precisely this traffic path on the
web is an attack vector against a host.  It makes perfect sense to
secure that attack vector.

  p3. Pervasive surveillance glass half empty/half full (Technical
solutions do not lead to justice):
  Prefer half full.

  p4. Encryption use a lot of power:
It is strictly true that encryption spends more CPU cycles - how much
could be estimated - I would expect single-digit % extra cycles, with
proper stack and browser implementations.
  Spending these single-digit extra cycles does not increase power usage
linearly, due to CPU caching and more.  I personally guess the true
power usage delta is less than 0.1% for ordinary web browsing.

  p5. IETF is forbidden from doing any work if there is a related
political debate on a topic:
  Disagree.

I do agree technical society should work closer with political society,
and I think this is happening increasingly.
It does not imply that a global political absolute consensus is required
for every Internet protocol update, because that will never work, and
will revert us to the stone-age.

Let the IETF improve what they can and at the same time meet politicians
half way. 

Best,
Martin

---

From: Stephane Bortzmeyer <[email-masked]>
Date: Wed, 4 Dec 2013 12:13:09 +0100

[List of recipients trimmed to be more reasonable.]

On Tue, Dec 03, 2013 at 05:25:40PM -0800,
 Bruce Perens <[email-masked]> wrote 
 a message of 37 lines which said:

>    [1]http://perens.com/works/ietf/perpass/appropriate-response/01.pdf

I fully agree with the idea that the problem is *political* and should
receive a *political* response. However, as you noted, IETF is not a
political forum and is not the right place for this sort of
action. But, if the *main* response should be political, the IETF can
still *help* by making mass surveillance more difficult. It is a
general principle in security: make laws but do not neglect technical
measures to make the lives of the attackers more difficult. We have
laws against burglary, for instance, but we still develop better
locks, and for good reasons. So, yes, the work of perpass is perfectly
legitimate and reasonable.

> Attacks on consumer privacy by commercial entities are generally
> within the domain of civil law. 

IANAL but this does not seem to me to be true. In my country,
collecting illegal personal data is a criminal offense.

> Technical attacks by sovereign powers are in general justified by
> those powers as being part of law enforcement. The justice of such
> enforcement is the topic of political discourse and the
> courts. [...] Technical responses to attacks on individual privacy
> by sovereign entities may be held as acceptable, criminal, or even
> treasonous conduct by those entities. [...] The proposers and
> implementers of systems intended to hinder law enforcement are
> arguably a criminal or treasonous conspiracy.

But the Internet is international. My surveillance (not me,
personally, but because it monitors everyone) by the NSA is certainly
illegal in my country. Whether or not it is legal in the USA is
irrelevant to me. Therefore, any technical measure against it is fair
game.

> None of these things [static JS or CSS files] are secret and there
> is little reason to obscure an individual's access to them.

Excuse me, but it seems you did not participate in the many
discussions about privacy in the last ten years. It is now well-known
that any information can be processed and used to find out about
users. Monitoring access to these files is one of the simplest means
to deduce (from the pattern of access) what an user is doing. There
are therefore many reasons to obscure it.

> There is also an energy cost: the electricity wasted by all of this
> encryption would likely result in megatons of additional carbon
> emitted from the burning of fossil fuel for electric generation, as
> well as otherwise-avoidable social and economic costs of renewable
> energy sources.

Is there a serious comparison somewhere about the relative cost of
encryption when we routinely access HD video files? I am not sure at
all that encryption is the main cost.

> Unfortunately, encryption doesn't help with this. The information
> being collected comes predominantly from web servers and browser
> tool bars, which are on the ends of the communication where it is
> necessarily decrypted. The server owners and software providers
> profit from using or selling user data.

Indeed, that's the main weakness of RFC 6973. But it is not a reason
to avoid encryption, because there are still threats by sniffing
third-parties. We have many holes by which private information
leak. We try to plug these holes. All of them. (Remember that the NSA
has PRISM, with the participation of the big Web silos like Google or
Facebook, but also has MUSCULAR - spying on unencrypted links -
because they prefer to have belts *and* suspenders. Following this
line, we have to secure both the endpoints and the links.)

> It's almost universally held within the working groups that users
> can't be responsible for their own security,

It is not IETF-specific, it is the opinion of most security experts,
backed by many observations and studies. This is not contempt, just
the recognition that a message "X.509 certificate has the wrong
issuer, do you want to continue?" is not easy to analyse and to act
upon, even for an expert. It is not fair to ask Mr Smith to decide
based on this information. He knows nothing about security (and that's
fine with me, I don't blame him for that, I know nothing about Mr
Smith's own area of expertise)

(Go to <https://ietf.org/> if you want a good laugh.)

---

From: Hannes Tschofenig <[email-masked]>
Date: Tue, 03 Dec 2013 22:08:19 +0000

On 12/04/2013 11:13 AM, Stephane Bortzmeyer wrote:
> problem is *political* and should
> receive a *political* response

I am not sure what "political" means.

The attacks we have seen are exploiting vulnerabilities others had
exploited before. Fixing security vulnerabilities in protocol
specifications, in implementations, and in deployments is something we
have done before.

Do you guys expect that someone (pick your favourite person) would say
"This is not good. You must not exploit security vulnerabilities in the
future anymore." Then, the Internet would be more secure.

I fail to see the story.

Ciao
Hannes

PS: To me it sounds like pushing responsibilities around without a clear
idea what that could mean.

---

From: Yoav Nir <[email-masked]>
Date: Wed, 4 Dec 2013 12:08:03 +0000

On Dec 4, 2013, at 1:13 PM, Stephane Bortzmeyer <[email-masked]> wrote:

> still *help* by making mass surveillance more difficult.

Or at least, making surreptitious surveillance more difficult. Although the political response should be discussed elsewhere, the technical requirements from protocols stem from the desired political response. Engineers don't get to make up the requirements.
 
> It is a
> locks, and for good reasons. 

It's even more true for the Internet attacks than for burglary. The police make some effort to stop burglaries. If your house is broken into, they will send a squad car and they will file a report, and they might even try to investigate. They are also watching for stolen property to get the thieves later on. They are not making anywhere near that effort for Internet crime. Try filing a report that someone sent you an email with a malware attachment. So as far as Internet crime is concerned, we're living in the movie version of the wild west, and we need to protect ourselves.

> irrelevant to me. Therefore, any technical measure against it is fair

Law enforcement in your own country should also go through some vetting process before they can force you to decrypt traffic for them, usually an order signed by a court of law. At least that is the way it should be in free countries (corollary: if you're forced to decrypt your laptop at the airport or at home without a specific warrant, that is not a free country)

> are therefore many reasons to obscure it.

True, and the files you access say a lot about you regardless of their content. I don't know what people who saw a list of the Wikipedia articles I've read would think of me. I shouldn't care about it either, because it's nobody's business what Wikipedia articles I've read. But we don't even have to go for the privacy example. Imagine a semiconductor company specializing in chips for routers and switches, with offices around the world, and we can get a log of the URLs that they access. All of the sudden we see from several of their offices requests going to the following URLs:

http://en.wikipedia.org/wiki/Zigbee
http://en.wikipedia.org/wiki/IEEE_802.15.4
http://en.wikipedia.org/wiki/Internet_of_things
http://www.ayu.ics.keio.ac.jp/~bingo/research/EI_CPSCom.pdf
http://tools.ietf.org/wg/core/
http://tools.ietf.org/photo/bormann-carsten.jpg
http://tools.ietf.org/photo/mcgregor-andrew.jpg
http://tools.ietf.org/html/draft-ietf-core-coap-18
http://tools.ietf.org/html/draft-ietf-core-http-mapping-02

I think we have just learned something about this company's future plans, which is information they have not made public. If we protect the confidentiality of requests, all we have here is access to Wikipedia and tools, which isn't nearly as revealing as the specific resources. That's a kitten-less argument for encrypting access to public resources.

> all that encryption is the main cost.

It really depends on what else you do with the data besides encrypting. The extreme example is a router than can either do or not do IPsec. In that case, you'll get around 10x or 20x the bandwidth with the non-encrypted traffic. For servers the ratio is much lower, because they have to do something to get the data that they intend to send, even if that just means loading the data from a file or database.
> (Go to <https://ietf.org/> if you want a good laugh.)

Gah. I expected this to be a www.ietf.org certificate vs a ietf.org URL, but this is far worse.

Yoav

---

From: S Moonesamy <[email-masked]>
Date: Wed, 04 Dec 2013 06:08:48 -0800

Hi Martin, Bruce, Stephane,
>anyway, so everybody would be happy...

Someone mentioned in a non-IETF discussion that there was a precedent 
about a technical question which might fit the above (3.146) 
argument.  It was recently mentioned in a news article that there is 
a public misconception about the Internet.  In my opinion it would be 
politically inappropriate for the IETF to state that some country 
would have to live without a protocol.

On page 1 of the document, it is mentioned that it is a:

   "deliberate attempt to defeat the correct technical operation of 
the Internet.
    In this case, the feature of communications privacy"

I would use "confidentiality" instead of "communications privacy" 
[1].  I agree that, as it is argued in the document, "attack" has a 
different meaning.

It is difficult to ignore the context.  I posted a draft (see 
http://tools.ietf.org/html/draft-moonesamy-traffic-peeking-00 
).  I'll be candid; the objective of a spying organization is to 
spy.  An in-depth discussion of that will alienate some IETF 
participants.  Not saying anything about [I don't know what word to 
choose] is an alternative.  Another alternative is to look at how the 
political problem affects the technical one.

The document argues that there is "no technical solution to this 
conundrum".  I agree to that.  An interesting point (in the document) 
is that "universal encryption of HTTP connections proposed on the 
working group mailing lists would hinder the technical operation of 
the internet".  I'd say yes.  In my opinion there are reasons why a 
person would consider having encrypted access to "static 
content".  For example, the "in the clear" access might disclose 
information which the user might be uncomfortable about.  One 
alternative is to provide the user and the other parties involved in 
the communication session with choices.  As Martin Millnert pointed 
out, providing those choices is not straight-forward.

I'll adapt a comment from Stephane Bortzmeyer:

   Is it okay to ask Mr Smith to decide based on the information 
[being provided]?

Or to put it differently, should a technical specification provide 
some guidance about that.

Regards,
S. Moonesamy

1. Credits to the Stephen Farrell and I'll take the blame if it is 
incorrect. :-)

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 09:09:44 -0800

On 12/04/2013 03:13 AM, Stephane
Bortzmeyer wrote:

But the Internet is international. My surveillance (not me,
personally, but because it monitors everyone) by the NSA is
certainly
illegal in my country. Whether or not it is legal in the USA is
irrelevant to me. Therefore, any technical measure against it is
fair
game.

France and the US are partners in NATO, and there are conflicting
reports regarding France's participation in something called
ECHELON.

The potential is that you could be giving aid and comfort to "the
enemy" by constructing a technical hinderance to intelligence
gathering by your own national intelligence agency or by your
country's intelligence partners. It looks from here that this falls
under the later paragraphs of France's penal code definition of
treason.

IMO this is reason to be careful.

Is there a serious comparison somewhere about the relative cost of
encryption when we routinely access HD video files? I am not sure
at
all that encryption is the main cost.

I'm sure it isn't. The point is just about unnecessary waste.

Thanks

Bruce

---

From: Theodore Ts'o <[email-masked]>
Date: Wed, 4 Dec 2013 12:12:07 -0500

>     under the later paragraphs of France's penal code definition of

We put door locks on homes.  This makes it harder for "black bag"
teams to put keyboard bugs on terrorists's homes.  (Or at least people
suspected of being terrorists.)

Does this mean that creating building codes which require that doors
have locks, or people who install locks on doors, are giving "aid and
comfort" to the enemy?

					- Ted

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 09:17:52 -0800

On 12/04/2013 09:12 AM, Theodore Ts'o
wrote:

Does this mean that creating building codes which require that
doors
have locks, or people who install locks on doors, are giving "aid
and
comfort" to the enemy?

Nobody cares what you do to your door. When your stated intention is
to prevent a nation from collecting information that they use for
law enforcement or national defense, they care.

Thanks

Bruce

---

From: Nicholas Weaver <[email-masked]>
Date: Wed, 4 Dec 2013 09:19:20 -0800

On Dec 4, 2013, at 9:17 AM, Bruce Perens <[email-masked]> wrote:

> On 12/04/2013 09:12 AM, Theodore Ts'o wrote:
>> Does this mean that creating building codes which require that doors have locks, or people who install locks on doors, are giving "aid and comfort" to the enemy?
> Nobody cares what you do to your door. When your stated intention is to prevent a nation from collecting information that they use for law enforcement or national defense, they care.

The problem we need the locks on ALL the doors to preserve national defense.

All it takes is ONE unencrypted web request across a hostile network for that hostile network to be used to attack the browser. 

--
Nicholas Weaver                  it is a tale, told by an idiot,
[email-masked]                full of sound and fury,
510-666-2903                                 .signifying nothing
PGP: http://www1.icsi.berkeley.edu/~nweaver/data/nweaver_pub.asc

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 09:22:57 -0800

On 12/04/2013 09:19 AM, Nicholas Weaver
wrote:

All it takes is ONE unencrypted web request across a hostile
network for that hostile network to be used to attack the browser.

And that is one way in to the browser out of many.

Thanks

Bruce

---

From: Nicholas Weaver <[email-masked]>
Date: Wed, 4 Dec 2013 09:23:57 -0800

On Dec 4, 2013, at 9:22 AM, Bruce Perens <[email-masked]> wrote:

> On 12/04/2013 09:19 AM, Nicholas Weaver wrote:

Except that it is a primary way that the NSA says is OK, and has a huge attraction to nation states for system exploitation.  Why bother with watering hole attacks etc?

---

From: Brian E Carpenter <[email-masked]>
Date: Thu, 05 Dec 2013 07:58:03 +1300

I've just read draft-farrell-perpass-attack-02 again.

It carefully doesn't discuss political, legal or societal issues.
It discusses monitoring and surveillance as a security threat model
and states that the IETF will specify technical counter-measures
to this threat model. That is well within the IETF's remit. Whether
implementors and operators choose to implement the resulting counter-
measures is a separate question that does have political, legal or
societal aspects.

I think that Bruce's concerns apply to deployment, not to the
IETF's work.

Regards
   Brian

On 05/12/2013 00:13, Stephane Bortzmeyer wrote:
> _______________________________________________
> perpass mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/perpass
>

---

From: Jacob Appelbaum <[email-masked]>
Date: Wed, 04 Dec 2013 19:55:24 +0000

Bruce Perens:
>> Does this mean that creating building codes which require that doors have 
>> locks, or people who install locks on doors, are giving "aid and comfort" to 
>> the enemy?
> Nobody cares what you do to your door. When your stated intention is to prevent 
> a nation from collecting information that they use for law enforcement or 
> national defense, they care.

Dear Bruce,

Why do you dignify these actions as 'law enforcement' or even as
'national defense' when we're discussing illegal spying?

Rosa Luxemburg said something terribly relevant and it bares repeating
after I've read your response:

   “Those who do not move, do not notice their chains.”

The early internet protocols have major security issues and it is time
to fix them. Pervasive surveillance, censorship and malware is a serious
threat regardless of your feelings about the NSA. The vulnerabilities
need to be fixed and pervasive strong end-user-controlled encryption is
part of the solution.

All the best,
Jacob

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 12:14:23 -0800

In my early teens I figured out how to tap telephones and actually
tapped a neighbor and my friend's cop neighbor. The conclusion of my
experimentation was that other people's phone calls are dreadfully
boring.

I don't particularly care if someone can reconstruct a pattern of
access from public file retrievals I make on the web. I can't
imagine why anyone would ever be interested.

I have NDAs with various companies and confidentiality orders from a
few courts, and I'm an insider stockholder for two companies. I'm
careful with that data. But casual stuff on the web? Nothing to hide
there.

Thanks

Bruce

---

From: Martin Thomson <[email-masked]>
Date: Wed, 4 Dec 2013 12:17:48 -0800

On 4 December 2013 12:14, Bruce Perens <[email-masked]> wrote:
> I don't particularly care if someone can reconstruct a pattern of access
> from public file retrievals I make on the web. I can't imagine why anyone
> would ever be interested.

I can.  You aren't thinking big enough.

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 12:29:20 -0800

On 12/04/2013 11:55 AM, Jacob Appelbaum
wrote:

Dear Bruce,

Because some of them are in my interest. And yours.

We have a nasty part of government that thinks it is in an an
endless war. Every liberal nation, historically, discontinues its
nice rights and protections during wartime.

But I don't kid myself that nothing that they are doing is done to
protect me and others like me from a zillion nut-cases who conspire
to do people harm and sometimes actually carry it out. I have met
some of those nut-cases.

Every society chooses its balance between freedom and enforcement.
Ours isn't the right balance today, agreed. But the proposals I see
here are the hacker approach - we're not patient to deal with this
as a political problem, so we'll change everyone's web browser.

Pervasive surveillance, censorship and malware is a serious threat regardless of your feelings about the NSA.

And will continue to be so after all web transactions are encrypted.
You're not going to actually solve any problems.

Thanks

Bruce

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 12:34:17 -0800

So, we're just going to give the entire
web all of the instructions, and we don't actually _care_ if they
implement HTTP 2.0 or not. We're not responsible if they do.

Sort of like handing someone a weapon, and then disclaiming
responsibility for what happens afterward because you had no idea
he'd actually use it!

Sorry, this seems to me to be specious.

Thanks

Bruce

On 12/04/2013 10:58 AM, Brian E Carpenter wrote:

Whether

---

From: Jacob Appelbaum <[email-masked]>
Date: Wed, 04 Dec 2013 20:29:32 +0000

Bruce Perens:
> On 12/04/2013 03:13 AM, Stephane Bortzmeyer wrote:
> In my early teens I figured out how to tap telephones and actually tapped a 
> neighbor and my friend's cop neighbor. The conclusion of my experimentation was 
> that other people's phone calls are dreadfully boring.

Imagine if this was admissible in court and that someone else was
telling this story about you? How would that have impacted your life?
How could it impact your life in the future?

> 
> I don't particularly care if someone can reconstruct a pattern of access from 
> public file retrievals I make on the web. I can't imagine why anyone would ever 
> be interested.
> 

That seems like quite a privilege, doesn't it? Not everyone is so lucky
as you - will you stand by their side or dismiss them simply because it
doesn't apply to you, in your view?

> I have NDAs with various companies and confidentiality orders from a few courts, 
> and I'm an insider stockholder for two companies. I'm careful with that data. 
> But casual stuff on the web? Nothing to hide there.

Do you use the same computer for browsing the web as you do for your
email? If so, I guess anyone who does would have some negligence to
hide, no?

Sincerely,
Jacob

---

From: Jacob Appelbaum <[email-masked]>
Date: Wed, 04 Dec 2013 20:35:17 +0000

Bruce Perens:
> On 12/04/2013 11:55 AM, Jacob Appelbaum wrote:
>> Dear Bruce,
>>

What about the illegal spying is in your interest? It certainly isn't in
my interest - I have been targeted for years by this spying and I most
certainly do not feel that it is in my interest.

I'm sure the non-Americans on the list would also love to hear about it too.

> 
> We have a nasty part of government that thinks it is in an an endless war. Every 
> liberal nation, historically, discontinues its nice rights and protections 
> during wartime.
> 

This is an oversimplification that is not legally correct.

> But I don't kid myself that nothing that they are doing is done to protect me 
> and others like me from a zillion nut-cases who conspire to do people harm and 
> sometimes actually carry it out. I have met some of those nut-cases.
> 

...

> Every society chooses its balance between freedom and enforcement. Ours isn't 
> the right balance today, agreed. But the proposals I see here are the hacker 
> approach - we're not patient to deal with this as a political problem, so we'll 
> change everyone's web browser.

This is the number one vector for the TAO at the NSA, fyi. Ensuring that
Man-on-the-Side is impossible will improve the security of everyone.
There will be other attack vectors, of course.

> And will continue to be so after all web transactions are encrypted. You're not 
> going to actually solve any problems.

I am actually working quite hard on solving these problems. We're having
this discussion partially because of my efforts, so please speak for
yourself and not for me, alright?

I look forward to seeing some more positive contributions from you. You
have a big brain and are a person of good character - come help us fix
the serious issues on the internet, Bruce.

All the best,
Jacob

---

From: Nicholas Weaver <[email-masked]>
Date: Wed, 4 Dec 2013 12:43:57 -0800

On Dec 4, 2013, at 12:29 PM, Bruce Perens <[email-masked]> wrote:

> We have a nasty part of government that thinks it is in an an endless war. Every liberal nation, historically, discontinues its nice rights and protections during wartime.

Unfortunately this nasty part of government is not just targeting the nutcases, but practically everybody, using insanely intrusive methods and setting series of insanely dangerous precedents.

How do you think the US would react to word that, say, the French or Chinese hacked AT&T (using packet injection, weaponizing the wiretaps), in order to practice covert surveillance upon senators and businessmen in the US?  "Ballistic" wouldn't begin to describe the reaction.  Not to mention the obvious economic targets [1] as well.

Yet now the NSA has said, "hey, its OK".  So if there is a reason for France, or China, or Russia, or Israel, or well anybody to not let their intelligence services off the leash?  

We know that the Chinese haven't been doing packet injection in the past (because we've caught their intrusions in the past, and they've been through phishing/watering hole), but they will in the future.  Because hey, why not?

Universal encryption is needed, NOW, not to limit the damage of surveillance but to reduce the huge attack surface that is now laid bare for the world.  

Your adversary is all countries which your traffic traverses except your own.

[1] The NSA is quite happy to say they don't give the information to US companies, but its quite clear that a non-trivial amount of espionage is to further US economic interests.  IMO, its a waste.  What good is hacking Petrobras if you do NOT give the data to Exxon/Mobil?

> And will continue to be so after all web transactions are encrypted. You're not going to actually solve any problems.

Yes, because unencrypted traffic is a huge open attack vector, which is now open-season.  Enjoy...

---

From: "Andreas Kuckartz" <[email-masked]>
Date: 4 Dec 2013 21:46:35 +0100

Bruce Perens:
> from public file retrievals I make on the web. I can't imagine why
> anyone would ever be interested.
> 
> I have NDAs with various companies and confidentiality orders from a few
> courts, and I'm an insider stockholder for two companies. I'm careful
> with that data. But casual stuff on the web? Nothing to hide there.

You sound like a troll. Anyway: Your personal life is irrelevant in this
discussion.

Cheers,
Andreas

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 12:50:05 -0800

On 12/04/2013 12:29 PM, Jacob Appelbaum
wrote:

Imagine if this was admissible in court and that someone else was
telling this story about you? How would that have impacted your
life?
How could it impact your life in the future?

It is admissible in court. It's a public statement on a mailing list
with a public archive. So I said it in public. Anyone who wants to
quote my statement that I tapped phones in my early teens can now do
so, in court or out of it.

I inhaled too. There it is, submit it to Slashdot or something. :-)

Not everyone is so lucky

I support their right to use a web browser that requests https
preferentially, if they think that will help. I would just like that
to be their choice, not something that is imposed upon them.

Do you use the same computer for browsing the web as you do for
your
email? If so, I guess anyone who does would have some negligence
to
hide, no?

I sat on the jury of a negilgence case earlier this year. There are
standards regarding common sense and what would reasonably be
expected for someone to perform. My security practices fit such
standards.

Thanks

Bruce

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 13:04:00 -0800

On 12/04/2013 12:35 PM, Jacob Appelbaum
wrote:

What about the illegal spying is in your interest?

I am not 100% confident that it is illegal, although I am unhappy
about FISA and a lot of other things done since 9/11. I testify for
a living. I could make a good case that it is illegal, and maybe
convince a court.

The part that is in my interest is that sometimes they do actually
catch people who are out to hurt others.

I happen to have walked through LAX terminal 3 two days before the
violence there, and I stayed in 7 World Trade Center a month before
9/11, traveling through the subway station and the main building
basements that were buried. I could just as likely have intersected
with the bad guys.

I am all for finding those guys before they can do harm. I am not
for giving espionage and law enforcement a blank check, though. And
I think there are obvious problems today that I'd like to fix
through the political process.

Thanks

Bruce

---

From: Brian E Carpenter <[email-masked]>
Date: Thu, 05 Dec 2013 10:26:25 +1300

On 05/12/2013 09:34, Bruce Perens wrote:
> So, we're just going to give the entire web all of the instructions, and we 
> don't actually _care_ if they implement HTTP 2.0 or not. We're not responsible 
> if they do.

That is exactly right. All IETF standards are voluntary standards.
Whether they are implemented or deployed is utterly outside the IETF's
hands.

> Sort of like handing someone a weapon, and then disclaiming responsibility for 
> what happens afterward because you had no idea he'd actually use it!

Engineers have certain ethical responsibilities, indeed. You could
certainly argue that the IETF has historically been too lax about
security and privacy vulnerabilities in our specifications - I reviewed
some of that history in my plenary talk in Vancouver - so what we
"handed over" was a network vulnerable to spying and spoofing.

> Sorry, this seems to me to be specious.

Exactly not. There is a clear line between the technology (which needs
to be secure) and society's use of the technology (which needs to be
ethical). The IETF is on the technology side, and our ethical
responsibility is to make the technology capable of being secure.

I think this thread is off topic for this list, so I will leave it there.

    Brian
> .

---

From: Ted Lemon <[email-masked]>
Date: Wed, 4 Dec 2013 16:27:57 -0500

On Dec 4, 2013, at 4:17 PM, <[email-masked]> <[email-masked]> wrote:
> Universal encryption is not a a laudable goal.

Unsupported assertions are not helpful.

---

From: <[email-masked]>
Date: Wed, 4 Dec 2013 21:17:00 +0000

+1. Perens' response is well worth reading.

(I'm also struck by the thought that Farrell's draft carefully defines 'attack', yet does not define 'defend'. To defend or not is a choice; that choice is neglected.)

Lloyd Wood
http://sat-net.com/L.Wood/

________________________________________
From: ietf [[email-masked]] On Behalf Of Bruce Perens [[email-masked]]
Sent: 04 December 2013 01:25
To: [email-masked]; [email-masked]; [email-masked]
Subject: perens-perpass-appropriate-response-01

    Thanks

    Bruce Perens

---

From: Jacob Appelbaum <[email-masked]>
Date: Wed, 04 Dec 2013 21:03:20 +0000

Bruce Perens:
> On 12/04/2013 12:29 PM, Jacob Appelbaum wrote:
>> Imagine if this was admissible in court and that someone else was telling this 
>> story about you? How would that have impacted your life? How could it impact 
>> your life in the future? 
> It is admissible in court. It's a public statement on a mailing list with a 
> public archive. So I said it in public. Anyone who wants to quote my statement 
> that I tapped phones in my early teens can now do so, in court or out of it.
> 

Did you notice that you decided about that disclosure?

> I support their right to use a web browser that requests https preferentially, 
> if they think that will help. I would just like that to be their choice, not 
> something that is imposed upon them.

It will help if it happens at scale - the masses of browsers being
secure by default ensures that not only the privileged will be secure.
Hardly anyone on the planet knows what 'https' is or how it works.

If you support their right to be secure, consider that you more
effectively support their rights by making it the default where
knowledgeable folks can opt-out; the other way around doesn't make sense.

>> Do you use the same computer for browsing the web as you do for your email? If 
>> so, I guess anyone who does would have some negligence to hide, no?
> I sat on the jury of a negilgence case earlier this year. There are standards 
> regarding common sense and what would reasonably be expected for someone to 
> perform. My security practices fit such standards.
> 

If I had to predict the future, I suspect that those standards will
change in 2014 and not in your favor.

All the best,
Jacob

---

From: Jacob Appelbaum <[email-masked]>
Date: Wed, 04 Dec 2013 21:31:00 +0000

Bruce Perens:
> On 12/04/2013 12:35 PM, Jacob Appelbaum wrote:
> I am not 100% confident that it is illegal, although I am unhappy about FISA and 
> a lot of other things done since 9/11. I testify for a living. I could make a 
> good case that it is illegal, and maybe convince a court.
> 

I'd encourage you to read some of the well written legal opinions by
folks like Jennifer Granick or heck, even the NYT:

http://justsecurity.org/2013/11/21/fisc-pen-register-opinion-its-matter-time-hurt/

http://www.nytimes.com/2013/08/09/opinion/breaking-through-limits-on-spying.html

> The part that is in my interest is that sometimes they do actually catch people 
> who are out to hurt others.
> 

Could you please cite a single case where the illegal NSA spying
programs have done that? I believe there is exactly one and it could
have been done legally. There are countless exmaples

> I happen to have walked through LAX terminal 3 two days before the violence 
> there, and I stayed in 7 World Trade Center a month before 9/11, traveling 
> through the subway station and the main building basements that were buried. I 
> could just as likely have intersected with the bad guys.
> 

Note that those examples happened with various levels of spying - in
some cases the full monty - so we not only have lost our civil
liberties, we've lost them without losing the danger, the risks or the
tragedy. Surely you see this plain reality, right?

I walked into Iraq in 2005 (as a journalist) and talked to people who
had their entire family murdered by our war machine. The NSA spying was
used in full during in our illegal war in Iraq. Surely, we should
consider this as part of the balance, right?

> I am all for finding those guys before they can do harm. I am not for giving 
> espionage and law enforcement a blank check, though. And I think there are 
> obvious problems today that I'd like to fix through the political process.
> 

Policy alone cannot fix the technical problems in a vacuum. We require
both policy and technology solutions. We should reflect on our ideas of
liberty and enshrine them in our technology.

I'd like to find the 'bad guys' too - have you looked at the NSA lately?
They're not the good guys when they commit crimes against the American
people or the rest of the world. Especially when they lie to the US
Congress, I might add.

There are real attackers and the NSA is merely one of them. We need to
secure the DNS against tampering (DNSSEC), against observation (to
resist specific targeting, censorship, etc) and we'll need to do similar
things to other protocols. If you look ahead a few years, I encourage
you to consider that your political fixes will not impact the Chinese,
Russian, British or even *my* capabilities without concrete technical
backing. That is one of the goals of perpass - to solve the technical
problems and with that, a policy person may be able to present a
political solution.

Currently, we lack both political and technical solutions to mass
surveillance.

Sincerely,
Jacob

---

From: Phillip Hallam-Baker <[email-masked]>
Date: Wed, 4 Dec 2013 16:39:42 -0500

On Wed, Dec 4, 2013 at 4:04 PM, Bruce Perens <[email-masked]> wrote:

> I am not 100% confident that it is illegal, although I am unhappy about
> FISA and a lot of other things done since 9/11. I testify for a living. I
> could make a good case that it is illegal, and maybe convince a court.
>

I am pretty sure that the Russian courts would consider the activities of
the NSA to be illegal.

The authorities in Brazil do as well.

And I am not at all keen on this idea that Alexander signed off on of using
raw intelligence data for 'swapsies' with foreign governments that have a
habit of murdering their political opponents (and using a British passport
to cover their tracks to boot!).

You have a very parochial view of the situation here and you are making the
rather ridiculous claim that people who disagree with you are committing
treason.

If the US wants to help in the fight against terrorism it will ban all
firearms and collect them for immediate disposal. Until that happens I see
no reason to take them seriously. The number of deaths due to terrorism is
inconsequential in comparison to the annual number of deaths due to
firearms.

-- 
Website: http://hallambaker.com/

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 14:42:42 -0800

On 12/04/2013 01:26 PM, Brian E
Carpenter wrote:

You could
certainly argue that the IETF has historically been too lax about
security and privacy vulnerabilities in our specifications - I
reviewed
some of that history in my plenary talk in Vancouver - so what we
"handed over" was a network vulnerable to spying and spoofing.

It was incredibly successful. There was a competing stack design in
the OSI protocols which went nowhere. IMO the reason for success was
the simplicity. Don't abandon that now.

Yes, the IETF protocols are voluntary. But IETF has a certain degree
of cachet by now, and there is a very high probability that the
industry will follow IETF's lead because of that. Which IMO
gives you the same responsibility that you would have if the
protocols were not mandatory.

Thanks

Bruce

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 15:09:14 -0800

On 12/04/2013 01:31 PM, Jacob Appelbaum
wrote:

programs have done that?

I don't know of any that you don't know of. I also don't believe
they can ever tell us the full story, whether it's good or bad,
because it would reveal operations and in some cases personnel.

I walked into Iraq in 2005 (as a journalist) and talked to people
who
had their entire family murdered by our war machine.

I never supported the Iraq war and it happened because so many were
fooled by the Bush Administration. I strongly doubt that the Bush
Administration did this because they had bad SIGINT.

We need to
secure the DNS against tampering (DNSSEC)

Um. This has been in process for 14 years without success? And now
you want _more_ encrypted protocols?

Currently,
we lack both political and technical solutions to mass
surveillance.

If there is any evidence that NSA is the slightest bit concerned
about this, I've not seen it. I would guess that their technical
capability is up to the task.

Political solutions have a chance of being effective.

Thanks

Bruce

---

From: Ted Lemon <[email-masked]>
Date: Wed, 4 Dec 2013 18:15:20 -0500

On Dec 4, 2013, at 12:09 PM, Bruce Perens <[email-masked]> wrote:
>> Is there a serious comparison somewhere about the relative cost of encryption when we routinely access HD video files? I am not sure at all that encryption is the main cost.

I don't know if you missed this or just don't consider it important, but essentially every video stream coming from a streaming video provider that is streaming copyrighted entertainment is encrypted.   The volume of encrypted data traversing the internet in streams of this type vastly outweighs the entirety of all traffic of the type that the IETF is currently talking about encrypting for privacy reasons.

---

From: Ted Lemon <[email-masked]>
Date: Wed, 4 Dec 2013 18:27:02 -0500

On Dec 4, 2013, at 3:29 PM, Bruce Perens <[email-masked]> wrote:
> Every society chooses its balance between freedom and enforcement. Ours isn't the right balance today, agreed. But the proposals I see here are the hacker approach - we're not patient to deal with this as a political problem, so we'll change everyone's web browser.

I think you're missing the point.   The point is not that the NSA can surveil you.   The point is that _anyone_ can.   The NSA is just who most publicly did it recently.   We know of a number of really successful attacks that have actually been done, in the real world, by law enforcement organizations, but that could be done as easily by a criminal organization.

The lesson here is not "okay, so let's stop law enforcement from eavesdropping."   It is "holy shit, we are really vulnerable."

As to the question of encryption generally, nobody questions (I hope) that we want our transactions with banks to be secure.   I think it's generally accepted that what videos we watch is private (there's a federal law in the U.S. making it illegal for video stores to give out that information).   The Supreme Court recently decided that the FBI couldn't put a GPS tracker on your car without a warrant.   So at least in the U.S., we are not navigating uncharted waters.   Yes, we have a problem with LEO spying.   But as a country, we do recognize the need for at least some communication to be confidential.   And this is not a legal understanding that is unique to the U.S.   Canadian appellate courts have held similarly, for example.

So whether you think LEO spying is a good idea or not, there is clearly a problem here with the protocols that we have deployed on the internet.   They make it too easy for _anybody_ to eavesdrop, and to use the information they acquire whilst eavesdropping in really nefarious ways (e.g. the watering hole attack someone referred to recently).   And it is entirely appropriate for the IETF to think very seriously about how to make these protocols more secure.

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 15:41:26 -0800

On 12/04/2013 03:27 PM, Ted Lemon
wrote:

As to the question of encryption generally, nobody questions (I
hope) that we want our transactions with banks to be secure.

And this is a solved problem except for the fact that they tend to
get unencrypted laptops stolen with our data. Which we can't solve
for them.

I think it's generally accepted that what videos we
watch is private (there's a federal law in the U.S. making it
illegal for video stores to give out that information).

They are private, and encrypted, but the encryption doesn't protect
us. It only "protects" the video provider who believes that the
whole internet will run away with their content if we are not
forcibly restrained. If it works at all.

They make it too easy for _anybody_ to eavesdrop, and
to use the information they acquire whilst eavesdropping in really
nefarious ways (e.g. the watering hole attack someone referred to
recently).

So, build browsers that request https preferentially. Publish that
as a recommendation. But please don't lock everyone into your
solution.

Thanks

Bruce

---

From: Jacob Appelbaum <[email-masked]>
Date: Wed, 04 Dec 2013 23:47:05 +0000

Bruce Perens:
> On 12/04/2013 01:31 PM, Jacob Appelbaum wrote:
>> Could you please cite a single case where the illegal NSA spying programs have 
>> done that?
> I don't know of any that you don't know of. I also don't believe they can ever 
> tell us the full story, whether it's good or bad, because it would reveal 
> operations and in some cases personnel.

So basically, you were just blowing smoke? OK!

>> I walked into Iraq in 2005 (as a journalist) and talked to people who had 
>> their entire family murdered by our war machine.
> I never supported the Iraq war and it happened because so many were fooled by 
> the Bush Administration. I strongly doubt that the Bush Administration did this 
> because they had bad SIGINT.

It happened because of similar arguments to those that you're making
here, actually.

>> We need to secure the DNS against tampering (DNSSEC)
> Um. This has been in process for 14 years without success? And now you want 
> _more_ encrypted protocols?

Good luck with a Man-On-The-Side attack on .se. domains that are
properly configured. While DNSSEC has a lot of problems, it is an
example of how to change the game, even if it is slow going. We've
learned a lot too.

>> Currently, we lack both political and technical solutions to mass surveillance.
> If there is any evidence that NSA is the slightest bit concerned about this, 
> I've not seen it. I would guess that their technical capability is up to the task.
> 

Huh? Did you totally miss my point, or what?

> Political solutions have a chance of being effective.

What political solution do you envision exactly? I'm really curious to
hear how you're going to defend your computer or from attackers with
nation state capabilities (or less) with a political solution. It has so
far failed for all of the nations subverted by the NSA surveillance.

Ask Chancellor Merkel how that process worked out for her cell phone, eh?

http://www.spiegel.de/international/world/merkel-calls-obama-over-suspicions-us-tapped-her-mobile-phone-a-929642.html

Guess what she did after she tried the political solution? I believe she
acquired some better hardware with meaningful crypto!

All the best,
Jacob

---

From: Ted Lemon <[email-masked]>
Date: Wed, 4 Dec 2013 18:55:13 -0500

On Dec 4, 2013, at 6:41 PM, Bruce Perens <[email-masked]> wrote:
>> I think it's generally accepted that what videos we watch is private (there's a federal law in the U.S. making it illegal for video stores to give out that information).
> They are private, and encrypted, but the encryption doesn't protect us. It only "protects" the video provider who believes that the whole internet will run away with their content if we are not forcibly restrained. If it works at all.

That's not my point.  My point is that if you are worried about cycles spent encrypting stuff, that's what you should be worried about, not the relatively trivial percentage of cycles that would go to encrypt http.

> So, build browsers that request https preferentially. Publish that as a recommendation. But please don't lock everyone into your solution.

The statements you've made thus far do not as far as I can tell provide any logical basis as a consequence of which the IETF could sensibly honor your request.   For example, you haven't explained why you think we should bowdlerize all our protocols to make sure that they are legal in even the most repressive state.

---

From: Jacob Appelbaum <[email-masked]>
Date: Thu, 05 Dec 2013 00:00:49 +0000

Bruce Perens:
> 
>>  They make it too easy for _anybody_ to eavesdrop, and to use the information 
>> they acquire whilst eavesdropping in really nefarious ways (e.g. the watering 
>> hole attack someone referred to recently). 
> So, build browsers that request https preferentially. Publish that as a 
> recommendation. But please don't lock everyone into your solution.

Wait, what?

Please don't lock everyone into well understood vulnerabilities?

Let us improve the protocols by opportunistically encrypting and when
you think you have nothing to hide, you can opt-out, right? You have
nothing to hide, right?

Speaking of which, what is the content of your /etc/shadow Bruce? :)

The attack surface of a browser is immense - the best way to protect
against exploitation is to ensure that there is transport layer security.

TLS (or something like it) helps us while we audit the image parsers,
the javascript engines and it helps mitigate injection that would
exploit vulnerable plugins; this is a very minimal amount of work to
protect a lot of attack surface. At least then we're nearly back to
watering hole attacks which requires, often, user interaction that is
very detectable.

I'd encourage you to read this:

 http://www.wired.com/opinion/2013/11/this-is-how-the-internet-backbone-has-been-turned-into-a-weapon/

Professor Weaver's article is very close to accurate. By the end of the
month, I believe there will be much more clarity on the topic. This is a
serious problem and it is internet wide.

Sincerely,
Jacob

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 16:05:27 -0800

On 12/04/2013 03:47 PM, Jacob Appelbaum
wrote:

So basically, you were just blowing smoke?

No. The organization is charged to protect us. However poorly or
well it's actually working, and I assume that I do not have the
whole story either way. They need reform, sure. Not elimination.

Throwing deliberate hurdles in their way is like spreading nails in
the path of a police car. Cops have more than enough abuses, but
most people accept that they do good stuff too, and nobody sensible
suggests getting rid of them.

Good luck with a Man-On-The-Side attack on .se. domains that are properly configured.

OK. But I'm horrified that .se is the best demo you can cite.

What political solution do you envision exactly?

Given the choice, I would roll increases in executive authority
related to the pursuit of war or espionage back to what we had
before the PATRIOT act. This is something we can state in one
sentence and that makes sense. IMO it is a workable campaign and one
you should join.

I'm really curious to
hear how you're going to defend your computer or from attackers with
nation state capabilities (or less) with a political solution.

How else can I defend my computer? I do not decieve myself that they
are stopped by any technical measure that you or I are capable of.
They can break down the door and water-board me if they want to. I
am completely helpless before them except for what I can achieve
politically.

Thanks

Bruce

---

From: Bruce Perens <[email-masked]>
Date: Wed, 04 Dec 2013 16:16:35 -0800

On 12/04/2013 03:55 PM, Ted Lemon
wrote:

The statements you've made thus far do not as far as I can tell
provide any logical basis as a consequence of which the IETF could
sensibly honor your request. For example, you haven't explained
why you think we should bowdlerize all our protocols to make sure
that they are legal in even the most repressive state.

I'm not sure that's even possible. But legality was not the only
reason I put forward. I am not in particular an NSA booster. My main
concerns are that this will harm the operation of the Internet and
take away user choice.

Thanks

Bruce

---

From: Ted Lemon <[email-masked]>
Date: Wed, 4 Dec 2013 19:21:41 -0500

On Dec 4, 2013, at 7:16 PM, Bruce Perens <[email-masked]> wrote:
> My main concerns are that this will harm the operation of the Internet and take away user choice.

Okay, there are two very definite statements.   You should be able to give examples.

If your example for user choice is "a person in a country with a repressive government will not have choice," that's not good enough, because they already lack choice due to their government—it's not something we have the power to do anything about.

If your example for "harm the operation of the internet" is transparent caching, that point has been answered: define a protocol for caching that is not transparent, and allow the incentive structure around end users who benefit from that caching to motivate them to use it, rather than simply forcing them to use it in their own best interest.

Indeed, this precisely addresses the needs of users in the first case, since their government can simply require them to go through the non-transparent cache.   They will know they are being watched, the government will be able to watch them, and they will be able to access any content they feel safe accessing in the awareness that they are being watched as they do so.   Everybody wins, for some value of "win."

---

From: Jacob Appelbaum <[email-masked]>
Date: Thu, 05 Dec 2013 00:30:58 +0000

Bruce Perens:
> On 12/04/2013 03:47 PM, Jacob Appelbaum wrote:
> No. The organization is charged to protect us. 

Us? Are you including the Dutch, German, Brazilian, Canadian, British
and Swedes on the list? Or just 'us' Americans?

It sounds to me like you're blowing smoke - specifically because they
aren't actually protecting us in the ways that they assert. Global
domination through criminal activity that results in hegemony? Sounds
solidly protectionist but not in a way where we've consented!

> However poorly or well it's 
> actually working, and I assume that I do not have the whole story either way. 
> They need reform, sure. Not elimination.

Ah, I see, you think we need spies outside the rule of law - that pretty
much sums up the problem. We either have the rule of law or we have this
- that is how we found ourselves here. The fact that you're not entitled
to know the whole story should tip you off that you might not want to
give them the benefit of the doubt regarding reform.

What is technically possible is effectively shown to be inevitable when
the economics line up for the NSA and friends.  Eliminate the NSA,
they're (mass) criminals; the DNI lies to Congress. The NSA gives full
feeds of their spying data to other nations. The examples are as
boundless as BOUNDLESSINFORMANT and beyond.

To boot they're hurting average Americans who write software. The taint
of the NSA is like the Chinese state security all over Huawei gear. I
think it is sadly deserved for many companies and their products.

> 
> Throwing deliberate hurdles in their way is like spreading nails in the path of 
> a police car. Cops have more than enough abuses, but most people accept that 
> they do good stuff too, and nobody sensible suggests getting rid of them.

I see that in your spare time, you're also a straw man factory; could
you knock it off Bruce? It is surprisingly annoying and a total derailment.

But while we're making funny jokes, I'll see you and raise you a muppet
video:

  https://www.youtube.com/watch?v=CjMLZuuXDRQ

Perhaps the discourse might be improved by not muddling intelligence
services and police? ;-)

> OK. But I'm horrified that .se is the best demo you can cite.

DNSSEC has issues - a lack of query privacy for example - but what do
you want? A full list of every DNSSEC enabled domain where someone has
to steal keys to begin to perform such an attack?

Here is some code by the way to implement QI:

 http://github.com/stealth/QI

> Given the choice, I would roll increases in executive authority related to the 
> pursuit of war or espionage back to what we had before the PATRIOT act. This is 
> something we can state in one sentence and that makes sense. IMO it is a 
> workable campaign and one you should join.

How do you propose that this will ensure we won't return here? And how
will your political successes impact your safety when it is another
government taking these actions?

> How else can I defend my computer? I do not decieve myself that they are stopped 
> by any technical measure that you or I are capable of. They can break down the 
> door and water-board me if they want to. I am completely helpless before them 
> except for what I can achieve politically.

Ah, I see. You're seriously wrong and pretty much provably so!

The documents released by Snowden clearly state it - as an example in
the Guardian Tor story, they specifically said that they can't
deanonymize everyone all the time - it forces them to target and to
target for memory corruption related exploitation specifically:

http://www.theguardian.com/world/2013/oct/04/nsa-gchq-attack-tor-network-encryption

http://www.theguardian.com/world/2013/oct/04/tor-attacks-nsa-users-online-anonymity

http://www.theguardian.com/world/interactive/2013/oct/04/tor-stinks-nsa-presentation-document

http://www.theguardian.com/world/interactive/2013/oct/04/tor-high-secure-internet-anonymity

Technical counter measures causes NSA dragnet surveillance to fail and
it reduces them to specific targeting of individuals. If you are
targeted, as I am no doubt targeted, you're right - you're probably not
up for the task. Seriously though - I would encourage you not to mistake
your inability with a general inability. I have computers where the NSA
would be foolish to touch them because the moment that they do, I'll
drop their technique, their payloads and everything related on the front
page of a major news paper. A political and a technical solution all in
one, as it should be, I might add.

Properly implemented cryptography works wonders and it will help reduce
a lot of suffering if we deploy it widely. I'm not sure why you refuse
to acknowledge this fact.

All the best,
Jacob

---

From: Stephane Bortzmeyer <[email-masked]>
Date: Thu, 5 Dec 2013 10:17:10 +0100

On Wed, Dec 04, 2013 at 02:42:42PM -0800,
 Bruce Perens <[email-masked]> wrote 
 a message of 51 lines which said:

>    It was incredibly successful. There was a competing stack design
>    in the OSI protocols which went nowhere. IMO the reason for
>    success was the simplicity.

Do note there is an entire (and excellent) RFC dedicated to the
reasons for success of a protocol, RFC 5218. Recommended reading before
continuing this discussion. 

Executive summary of RFC 5218: better to have no security at the
beginning (in order to be simple and easy) *but* to be able to add it
later (because with success come security problems).

---

From: Joseph Lorenzo Hall <[email-masked]>
Date: Thu, 05 Dec 2013 09:09:06 -0500

> under the later paragraphs of France's penal code definition of

(apologies this is long... hopefully it's fun to read)

Hi Bruce,

It's probably been a bit less than a decade since last we spoke, I
hope you are well.

Like many, I find much to disagree with in your draft response.

First, I wouldn't use the adjective "political" but "policy"
indicating that in addition to the technical side of communications
infrastructure, there are also norms, rules, and laws to which we as a
society agree (either globally through commitments to human rights or
locally through culture, laws, and norms).

There are many of us -- although I'd say not nearly enough, we're all
hiring! -- that work in the policy space and try to advocate carefully
for why the current state of affairs (and where entities like the USG
want to go in the future) can not stand. A democracy is not a
democracy if it is in a constant state of pervasive surveillance.

At CDT we've worked with many people on this list -- and whome you
likely know -- to advocate for infrastructural security and to point
out that many, many countries are involved in essentially attacking
users against the more broad public interest:

https://www.cdt.org/files/pdfs/CALEAII-techreport.pdf
https://www.cdt.org/files/pdfs/nsa-review-panel-tech-comment.pdf

On the "downstream side, many of you may have missed this 2-year
effort (before Snowden!!) to document "systematic access", or
governments of the world demanding access to data the private sector
holds... i.e., it's certainly not just the U.S. or FVEY countries
exploiting data the private sector holds but increasingly every
sovereign entity (note one of the authors, Lee, was a former general
counsel to the NSA):

https://www.cdt.org/systematic-access
https://cdt.org/files/pdfs/govaccess2013/government-access-to-data-comparative-analysis.pdf

The reason I excerpted what you say above is the following: just like
it used to be many decades ago, the government cannot tap everything.
That is a fact. There are methods of communication that it will not be
able to tap, and there will be standards and tools that enable highly
secure communication. It seems overwhelmingly rational to protect
communications against strong adversaries in the passive case
("upstream" so to speak) and to beef up but not eliminate methods of
surveillance that are both legal and further the public interest in
safety as narrowly as possible.

The reason the NSA, CIA, etc. in the US and FVEY countries can collect
so much information is a combination of path dependence -- standards
did not contemplated pervasive threats and our daily lives are
increasingly mediated by protocols -- and over-zealous "we can, so we
will" thinking inspired by a state of terror.

Let me say that more clearly: if terrorism's goal is to put a populace
into a state of terror, this has certainly been accomplished for our
intelligence agencies, who justify any encroachment on the lives of
normal citizens as "why not? if it saves 1 person"... without thinking
about the very Heisenbergian conundrum that the act of pervasive
surveillance -- and not just how it is executed -- will undoubtedly
move us farther from democracy (and yes there are many other things
that affect that... e.g., campaign finance, voting technology, and
voting rights).

What I would like to see is a recognition and acceptance that there
will be secrets that governments can not know, and that they will
inevitably have to get back to actual police work -- not exploiting
the fabric of globally digital society.

This is why it is imperative to many of us to make sure the technical
side supports this to the best of our ability... as Nick said later on
this thread, without pervasive encryption we are vulnerable to
numerous adversaries, despite what you think of their intentions and
goals (and effectiveness, as Jake rightly notes, is simply a joke).

best, Joe

- -- 
Joseph Lorenzo Hall
Chief Technologist
Center for Democracy & Technology
1634 I ST NW STE 1100
Washington DC 20006-4011
(p) 202-407-8825
(f) 202-637-0968
[email-masked]
PGP: https://josephhall.org/gpg-key
fingerprint: 3CA2 8D7B 9F6D DBD3 4B10  1607 5F86 6987 40A9 A871

---

From: Eliot Lear <[email-masked]>
Date: Thu, 05 Dec 2013 22:10:29 +0000

Hi Ted,

> If your example for "harm the operation of the internet" is transparent caching, that point has been answered: define a protocol for caching that is not transparent, and allow the incentive structu…

It's fine to have aspirations, and establishing an architecture in which
intermediaries can be properly identified and authorized is important. 
However, let's not take aspirations that do not even exist in the form
of an Internet-Draft, assume them as fact, and dismiss those who live in
the real world where caching is a necessity in bandwidth-constrained
environments.

Please let's take this step by step.  A few drafts that get us there
seem in order.

Eliot

---

From: Pranesh Prakash <[email-masked]>
Date: Thu, 05 Dec 2013 23:53:09 -0500

> No. The organization is charged to protect us. 

1. Speak for yourself. The NSA is not charged with protecting
non-Americans, i.e., the bulk of the population of the world, I may add,
of the bulk of the users of the Internet standards that the IETF works
on.  The clue is in the word "National".  India's National Technical
Research Organization is not charged with protecting Chinese or
Americans either.

2. Try telling that to the folks at Petrobras and all the diplomats at
the UN HQ, the Indian Embassy in DC, the EC/CoE/European Council, G20
leaders, and those people whose porn habits were recorded for blackmail
purposes.

This is not a debate about whether surveillance is good or not.
(Targetted surveillance which is allowed by a law, has a legitimate aim
in a democratic society, is not arbitrary, is necessary to achieve those
aims, is proportionate, authorized by a judicial process, etc., would be
legitimate.)  This is a debate about whether it is technically (and
politically) desirable for protocols to prevent mass surveillance.

> they do good stuff too, and nobody sensible suggests getting rid of them.

That analogy is woefully inadequate.  Spreading nails in the path of a
police car is a targetted attack on the police car.  Increasing
encryption to improve confidentiality of communications is not a
targetted attack against anyone.

This, on the other hand, is like ensuring that you write *all* your
communications in coded language instead of just some of your communication.

Will it frustrate targetted surveillance that complies with the standard
set in the International Covenant on Civil and Political Rights of being
"non-arbitrary" and "lawful"?  Probably not, since there are other ways
of getting to such targets by gaining access through their service
providers or by gaining access to their person or to their communication
devices.

Will it frustrate mass surveillance / dragnet surveillance?  Yes.  The
choice is clear to me.

> workable campaign and one you should join.

I can't join it; I'm not a US citizen.  Nor do I want to make the lack
of security of the protocols that I use hostage to the some 'workable
campaign' run by well-meaning Americans.  I will whole-heartedly support
you in your campaign to reform the law and policies in the USA.

I don't see why you see technical and political solutions as being
mutually exclusive.

There is no reason why the 'default' insecurity of HTTP cannot be
handled at the technical level.  Do I believe all HTTP2 traffic MUST be
encrypted?  Perhaps, and perhaps not.  But most certainly, the 'default'
for HTTP2 traffic should be encryption.

You can opt out of the Concealment Society if you want to.  But please
don't force me to stay within the Surveillance Society.

-- 
Pranesh Prakash
Policy Director
Centre for Internet and Society
T: +91 80 40926283 | W: http://cis-india.org
PGP ID: 0x1D5C5F07 | Twitter: @pranesh_prakash
--------------------
Access to Knowledge Fellow
Information Society Project, Yale Law School
T: +1 520 314 7147 | W: http://yaleisp.org

---

From: SM <[email-masked]>
Date: Fri, 06 Dec 2013 01:20:17 -0800

Hi Pranesh,
>politically) desirable for protocols to prevent mass surveillance.

I read 
http://cis-india.org/internet-governance/blog/indias-big-brother-the-central-monitoring-system 
There are likely similar cases in other countries.

What could be the effect if (widely deployed) IETF protocols 
prevented such systems from working?  It is possible to design a 
protocol which does not allow "in the clear" traffic [1].  It is not 
clear whether such a protocol would be widely deployed.

>for HTTP2 traffic should be encryption.

Ok.

Regards,
-sm

1. That is different from the "default".

---

From: "Andreas Kuckartz" <[email-masked]>
Date: 6 Dec 2013 12:30:56 +0100

SM:
> What could be the effect if (widely deployed) IETF protocols prevented
> such systems from working?  It is possible to design a protocol which
> does not allow "in the clear" traffic [1].  It is not clear whether such
> a protocol would be widely deployed.

Jörg Ziercke, the president of the German Federal Criminal Office (BKA)
three weeks ago suggested to restrict the right to use Tor by requiring
the registration of users.

Standards can not solve such political and legal attempts to attack the
privacy and security of users.

But that should not prevent the development of standards which disable
mass surveillance when those standards are deployed.

Cheers,
Andreas

---

From: Jacob Appelbaum <[email-masked]>
Date: Fri, 06 Dec 2013 11:49:02 +0000

> the registration of users.

Herr Ziercke clearly does not understand how Tor or even how IP networks
actually function.

> privacy and security of users.

I agree that standards will not solve political problems in the
political sphere. Standards will however limit the political and legal
options - as an example - forward secrecy with DHE makes forced key
disclosure irrelevant for retroactive decryption - the past traffic
cannot be decrypted as the session key is not derived from the identity
key.

> mass surveillance when those standards are deployed.

I agree.

All the best,
Jacob

---

From: SM <[email-masked]>
Date: Fri, 06 Dec 2013 09:01:25 -0800

Hi Andreas,
>the registration of users.

Here is an (unverified) comment from someone working for the BKA:

   "Egal wie man diskutiert, man muss sich hier entscheiden, ob man den
    Ermittlungserfolg will oder nicht."

>mass surveillance when those standards are deployed.

The short answer is yes.

Regards,
-sm

---

From: Paul Ferguson <[email-masked]>
Date: Fri, 06 Dec 2013 10:46:24 -0800

> don't force me to stay within the Surveillance Society.

I really like this quote. Mind if I use it?  :-)

- - ferg

-- 
Paul Ferguson
PGP Public Key ID: 0x63546533

---

From: Bruce Perens <[email-masked]>
Date: Fri, 06 Dec 2013 10:53:16 -0800

> don't force me to stay within the Surveillance Society.

This will be just fine if it's true. How do I opt out of the
Concealment Society if browsers and servers implement HTTP 2.0 as
proposed, eventually dropping support for HTTP 1, and neither the
browser or server have an in-the-clear mode?

That's really all this discussion is about. Not any advisory to run
https preferentially, but the fact that http isn't being left in the
standard.

Thanks

Bruce

---

From: Nicholas Weaver <[email-masked]>
Date: Fri, 6 Dec 2013 10:58:04 -0800

On Dec 6, 2013, at 10:53 AM, Bruce Perens <[email-masked]> wrote:

> This will be just fine if it's true. How do I opt out of the Concealment Society if browsers and servers implement HTTP 2.0 as proposed, eventually dropping support for HTTP 1, and neither the browser or server have an in-the-clear mode?
> 
> That's really all this discussion is about. Not any advisory to run https preferentially, but the fact that http isn't being left in the standard.

Include a checkbox in the browser saying "Fuck it all, show my data to the world" which broadcasts the session key in the clear.

And see how many people click on it...

Unencrypted traffic is a vulnerability.  Failing to close a vulnerability that is going to be exploited by every nation on the planet but your own is lunacy.

---

From: Bruce Perens <[email-masked]>
Date: Fri, 06 Dec 2013 11:19:54 -0800

On 12/06/2013 10:58 AM, Nicholas Weaver
wrote:

Include a checkbox in the browser saying "Fuck it all, show my
data to the world" which broadcasts the session key in the clear.

I know you intended this to be sarcastic, but opting out of the
concealment society does not mean that the user doesn't have the
sense to conceal things when it is actually necessary, vs. when it
is in their honest opinion an off-the-scale response to the problem.

Punishing them by revealing their credit card numbers is not an
appropriate response to their wanting to load static images,
javascripts, and CSS in the clear.

Thanks

Bruce

---

From: Nicholas Weaver <[email-masked]>
Date: Fri, 6 Dec 2013 11:31:23 -0800

On Dec 6, 2013, at 11:19 AM, Bruce Perens <[email-masked]> wrote:

> On 12/06/2013 10:58 AM, Nicholas Weaver wrote:
> I know you intended this to be sarcastic, but opting out of the concealment society does not mean that the user doesn't have the sense to conceal things when it is actually necessary, vs. when it is in their honest opinion an off-the-scale response to the problem.
> 
> Punishing them by revealing their credit card numbers is not an appropriate response to their wanting to load static images, javascripts, and CSS in the clear.

Then make the checkbox "Fuck it all, show my data to the world IF THE SERVER CONSENTS", and have the leakage require both the server and client.  I'm not kidding here. 

Cleartext without data integrity is a outright risk on the current and future Internet.  I don't care about surveillance.  (Well, I do, but...).   What I care about is attack surface for exploitation, an attack surface that is enormous, easy to use, and hey, the US government said "Game on!", and where everyone else can say "It wasn't me.  And hey, even if it was, you started it, sauce pour l'oie..."  

Especially for "javascripts and CSS" which you seem so happy to pass in the clear:  You let an attacker see a SINGLE ONE of your cleartext JavaScript or CSS fetches and you are FUBAR.  Game over, you're p0wned, have a nice day.

---

From: Bruce Perens <[email-masked]>
Date: Fri, 06 Dec 2013 11:48:44 -0800

On 12/06/2013 11:31 AM, Nicholas Weaver wrote:

So, first lose the obnoxious part. Then, provide them with a real choice:

1. Use HTTP preferentially except where the server specifies HTTPS. Servers will generally specify HTTPS for credit cards, login screens, and other sensitive data. This is potentially the fastest method, but the least secure.
2. Always use HTTPS preferentially for the body page and URLs from the address bar or bookmarks, but load embedded resources within the page using HTTP unless the server directs otherwise. This is a good compromise for most people.
3. Always use HTTPS preferentially for all requests. This is potentially most secure and slowest.

Then make the default whatever your preference is.

See your fetches? I understand MITM, etc., but see them?

    Thanks

    Bruce

-- 
Sent from my Android phone with K-9 Mail. Please excuse my brevity.

---

From: Nicholas Weaver <[email-masked]>
Date: Fri, 6 Dec 2013 13:20:46 -0800

> Then make the default whatever your preference is.

The default MUST BE "ALWAYS HTTPS, ALWAYS".  Period.  Anything less is abdicating user safety.

> See your fetches? I understand MITM, etc., but see them?

Yes, SEE just one of these "inconsequential" fetches is sufficient.  If the attacker can see your fetches he can execute a man-on-the-side attack through packet injection.  A wiretap is only passive if the wiretapper doesn't want to bother spending the couple of hours of from-scratch code to turn it into an active attacker.

Lets take a concrete example.  

You, Bruce, have nothing to fear from the US government.  But hey, you're doing stuff of some economic significance, and economic significance = valid tagret.  Therefore, in this brave new world, you're a valid target to say, well, France. [1]  And France's wiretap infrastructure knows the IP you commonly use (there are several tricks to possibly find this out).

All the wiretap has to do is wait for that single inconsequential Javascript fetch from your computer to pass by the wiretap, say, as part of a completely innocent and unrelated Air France ad campaign that happened to be on a web page you happened to visit.

When it sees the TCP packet containing the HTTP GET, it spoofs an injected reply packet back to you.  If your browser gets the spoofed reply first (and it will, the spoofed reply has a head start in the race), it acts on the spoofed reply.

This spoofed reply contains a small piece of Javascript which creates a little, tiny 1x1 hidden iFrame that opens onto France's exploit server [2], which now runs a full suite of code in your browser to p0wn you.  

Actually doing packet injection is downright trivial:  I've written up a TCP packet injector in a few hours on a lark, and several years ago it was a staple of Defcon WiFi pranks, say, by turning every large image into goat.se. Off the shelf tools and a little glue are pretty much sufficient for any country to do this [3]. 

In the past, it was only the purvue of pranksters and censorship (the Great Firewall).  And, it turns out the NSA.  Thanks to the NSA, now the future of packet injection is not, well, bright, but readily available to a whole UN worth of attackers.

So yes, a single fetch seen by the adversary is sufficient if the adversary wants to attack you.  If you are lucky, your adversary is all countries your traffic traverses except your own.

[1] I selected Country B, err, France for a reason in this.  http://www.foreignpolicy.com/articles/2013/07/01/espionage_moi_france

But pick your country.  

[2] The NSA's software suite for this is called FOXACID.  Everybody else just uses Metasploit's Browser Autopwn, its the same thing. 

[3] For those without the exploit expertise, please contact your local FinFly, Hacking Team, and Vupen sales representatives.  They'd be happy to help provide malcode and exploits to tie into your Metasploit autopwn system. The packet injector itself?  Just have an undergrad write it.  Its a good lab exercise for a networking class.

---

From: "Andreas Kuckartz" <[email-masked]>
Date: 6 Dec 2013 22:34:26 +0100

> Herr Ziercke clearly does not understand how Tor or even how IP networks

Maybe. Unfortunately his proposals likely would get worse the more he
knows about the technologies.

Cheers,
Andreas

---

From: Ralf Skyper Kaiser <[email-masked]>
Date: Fri, 6 Dec 2013 22:17:33 +0000

Hi Bruce,

I understand that you have some doubts why we want to make pervasive
surveillance harder and if pervasive
surveillance is bad and draft-farrell-perpass-attack-00.

I encourage you to read the Universal Declaration Of Human Rights [1]. Your
country is a signatory to this declaration.

You do not need to read the entire declaration. In fact I only ask you to
read the Preamble itself. You do not
have to read any further than the second sentence of the Preamble which
reads:

"Whereas disregard and contempt for human rights have resulted in barbarous
acts which have outraged the
conscience of mankind, and the advent of a world in which human beings
shall enjoy freedom of speech and
belief and freedom from fear and want has been proclaimed as the highest
aspiration of the common people"

North Korea, East Germany and the Stasi are just some examples where
pervasive surveillance and the violation of
this declaration leads to.

I also understand that you are saying 'that you have nothing to hide'.

I encourage you to book a holiday in Iran. While there please browse some
gay websites. Then see what happens
to you when you leave the country and please report back to us your opinion
on pervasive surveillance afterwards.

I promise a mind-changing experience.

I am happy for you that you are living in a bubble where all this does not
concern you (I really am). But sadly it
concerns others and luckily we do not design the properties of the Internet
to fit just your needs.

Further on your "I have nothing to hide" argument  I kindly ask you to
install a video camera on
your toilet and send the link of the webcam to this list. Still nothing to
hide? Feeling good?

There was also the discussion why we lock our house doors. There is some
similarity with pervasive surveillance.
Maybe you should hand a copy of your key to us.

This way we can come around, unannounced and on our terms, without telling
you, at any time, just to
check up on you to make sure you are alright. It's for your own good!

And that's what's happening with pervasive surveillance and there is an
overwhelming consensus that this
is not for our own good!

regards,

skyper

[1] http://www.un.org/en/documents/udhr/

---

From: Bjoern Hoehrmann <[email-masked]>
Date: Sat, 07 Dec 2013 00:32:13 +0100

>your toilet and send the link of the webcam to this list. Still nothing to

It is interesting that this counter-argument is extremely common to the
exclusion of most others. For instance, it is rarely pointed out that
while resources are expended searching those who have nothing to hide,
those who do have something to hide have time to get away or to improve
their hiding methods, dispose of whatever they are hiding, or to commit
more actions that would justify searching them.

It is also uncommon to point out in response to this argument that by
revealing things about ourself, we may also reveal things about others,
which might do damage to common goods. You cannot have free elections,
for instance, if most people reveal how they vote. I want others to hide
how they voted so I can vote freely; so the Golden Rule gives me some-
thing to hide.
-- 
Björn Höhrmann · mailto:[email-masked] · http://bjoern.hoehrmann.de
Am Badedeich 7 · Telefon: +49(0)160/4415681 · http://www.bjoernsworld.de
25899 Dagebüll · PGP Pub. KeyID: 0xA4357E78 · http://www.websitedev.de/

---

From: John Wroclawski <[email-masked]>
Date: Fri, 6 Dec 2013 16:00:04 -0800

Folks interested in this line of discussion should definitely take a look at the writing of Daniel Solove, particularly “‘I’ve Got Nothing to Hide’ and Other Misunderstandings of Privacy”, available at <http://papers.ssrn.com/sol3/papers.cfm?abstract_id=998565>. Beyond that, his newer book <http://www.amazon.com/gp/product/0300172311> covers this space and more in greater depth.

---

From: Bruce Perens <[email-masked]>
Date: Fri, 06 Dec 2013 23:21:10 -0800

I have read a lot of absurd arguments on this list over the past 24
hours:

A GUI with a button title like "F**k security, I want to open myself
to the world".

Put a camera in your bathroom.

Go to Iran (I would certainly act differently if I was there, and
did in Tunisia).

Make polls public.

Don't use HTTPS even where it's appropriate.

People who don't necessarily want to encrypt everything don't have
any reason to do this silly stuff and you don't win arguments this
way.

Thanks

Bruce

---

From: Bruce Perens <[email-masked]>
Date: Fri, 06 Dec 2013 23:26:21 -0800

On 12/06/2013 02:17 PM, Ralf Skyper
Kaiser wrote:

There was also the discussion why we lock our house doors.

I was brought up to believe that the places where you had to lock
yourself in at night were bad places to live. We only started
locking the doors at night in my home in Bayville, Long Island
sometime in the 80's as a result of a local crime wave.

Oops, I forgot to include this in the list of absurd arguments. Try
winning the argument without suggesting a camera in my bathroom,
etc.

---

From: Bruce Perens <[email-masked]>
Date: Fri, 06 Dec 2013 23:29:46 -0800

On 12/06/2013 01:20 PM, Nicholas Weaver
wrote:

If the attacker can see your fetches he can execute a man-on-the-side attack through packet injection.

This is the first one I've seen that is actually compelling. But
it's an authentication problem rather than a confidentiality one.

---

From: Bruce Perens <[email-masked]>
Date: Fri, 06 Dec 2013 23:46:23 -0800

John,

Of course I have sympathy for all of those who have their human
rights abridged, and would not begrudge them the use of Tor,
preferential https, or whatever helps. I am not sanguine that
encryption is any barrier to NSA due to the ASIC issue previously
discussed, but it might well be a barrier to religious extremist
oppressors, etc.

The problem with security is that however much you have is never
enough, because there's always a new threat. And that is exactly why
the United States is pursuing a continuously increasing war in
whiich surveilance and odious security procedures only increase. And
thus IETF will also end up on a continuously increasing war in which
odious security procedures only increase, in response.

The next step after encrypting every web query is locking down the
browser to the "trusted platform" and insisting on identifying
certificates for all users. Our various corporate totalitarians are
sure to want it, it already exists on the iPhone and other DRM
platforms, and will only get tighter.

So, this ends with the death of the open web.

At some point, we have to draw a line and say this is enough, it
doesn't really protect us, it protects someone else at our expense.

Where do you propose to do that? Right after _this_ change? And when
the next proposal is to draw the line right after the _next_ change,
and so on ad infinitum?

So, I don't want to be forced onto this next security upgrade. I
want to be able to intelligently decide whether I need it and when,
and to control whether I use it, and when to dispense with it when
it's being used for things that are not in my interest.

Thanks

Bruce

---

From: Jacob Appelbaum <[email-masked]>
Date: Sat, 07 Dec 2013 09:33:42 +0000

Bruce Perens:
> On 12/06/2013 02:17 PM, Ralf Skyper Kaiser wrote:
>>
> I was brought up to believe that the places where you had to lock yourself in at 
> night were bad places to live. We only started locking the doors at night in my 
> home in Bayville, Long Island sometime in the 80's as a result of a local crime 
> wave.

Welcome to the internet with the NSA/CSE/GCHQ/GCSB/BND/FSB for nearly
everyone in the world, Bruce. We're starting to protect communications
because of an international crime wave and widespread vulnerability.

All the best,
Jacob

---

From: Jacob Appelbaum <[email-masked]>
Date: Sat, 07 Dec 2013 09:36:52 +0000

Bruce Perens:
> On 12/06/2013 01:20 PM, Nicholas Weaver wrote:
> This is the first one I've seen that is actually compelling. But it's an 
> authentication problem rather than a confidentiality one.

Without confidentiality, a user may be targeted for specific tracking
and more importantly, they may be targeted for client side exploitation.

Do you find that compelling?

All the best,
Jacob

---

From: Jacob Appelbaum <[email-masked]>
Date: Sat, 07 Dec 2013 10:11:57 +0000

Bruce Perens:
> John,
> 
> Of course I have sympathy for all of those who have their human rights abridged, 
> and would not begrudge them the use of Tor, preferential https, or whatever 
> helps. 

Really? Where is your sympathy exactly? I am one of those who have my
human rights abridged, as is everyone on this list, I might add. It is
nearly impossible for me to protect myself, even with Tor, because
nearly all services and systems are insecure in the face of specific
attacker capabilities.

Is your sympathy simply that you begrudgingly will allow us to protect
ourselves from your (and my) spy agency, the NSA? Some sympathy!

> I am not sanguine that encryption is any barrier to NSA due to the ASIC 
> issue previously discussed, but it might well be a barrier to religious 
> extremist oppressors, etc.

Do you understand how the TURMOIL and TURBINE programs work? The first
is a passive sensor system that does DPI (Deep Packet Inspection) and
the second is an active sensor system that does DPI (Deep Packet Injection).

The TURMOIL system is used for protocol classification and selector
based surveillance. The TURBINE system takes actions, usually packet
injections for Man-on-the-Side, based on the results of TURMOIL and
similar systems.

For any agency to build a system like TURMOIL, they must be able to scan
the traffic in real time. The time to race a TCP connection is very
small and as it stands, they do not win all of the time - latency of
injection provides enough variance to stop QUANTUMINSERTION related attacks.

Do you have any evidence that these systems use super computer, ASIC or
FGPA based decryption techniques as part of the TURMOIL or TURBINE programs?

It is clear that they do decryption from captured and stored data. It is
also clear that they cannot store *everything* and so traffic analysis
is part of how they decide what to store and thus how they are able to
record the ciphertext for later attacks. Only basic traffic analysis
resistance in common protocols will start to change this balance.

This is part of how we will end massive surveillance of the internet. We
will not end mass surveillance by keeping the current economic balance
and the current social cost that is afforded to these spies and other
criminals.

> 
> The problem with security is that however much you have is never enough, because 
> there's always a new threat. And that is exactly why the United States is 
> pursuing a continuously increasing war in whiich surveilance and odious security 
> procedures only increase. And thus IETF will also end up on a continuously 
> increasing war in which odious security procedures only increase, in response.
> 

This is false.

A key problem here is that you refuse to acknowledge that well known,
even practically solved problems, are a threat to the users of the internet.

TLS for HTTP will reduce the attack surface of every computer from third
party network based threats. We can very nearly eliminate these threats
entirely and we can ensure that when the threat becomes reality, we may
detect it and fail in a closed manner.

> The next step after encrypting every web query is locking down the browser to 
> the "trusted platform" and insisting on identifying certificates for all users. 
> Our various corporate totalitarians are sure to want it, it already exists on 
> the iPhone and other DRM platforms, and will only get tighter.
> 

This is a red herring and is also false.

> So, this ends with the death of the open web.

The NSA has killed the open web as we know it. The Chinese "Great"
firewall has killed the open web that most of China *never* knew anyway.

> At some point, we have to draw a line and say this is enough, it doesn't really 
> protect us, it protects someone else at our expense.
> 

The question I ask myself, Bruce, is if at some point, you're working to
the benefit of someone else? You certainly don't seem to care about the
common good in the face of real threats because of your privilege as a
US citizen and your general arrogance rooted in other privileges.

> Where do you propose to do that? Right after _this_ change? And when the next 
> proposal is to draw the line right after the _next_ change, and so on ad infinitum?
> 

Attacks generally improve over time. We must iterate on protocols that
have serious flaws and ensure that we defend against attackers.

> So, I don't want to be forced onto this next security upgrade. I want to be able 
> to intelligently decide whether I need it and when, and to control whether I use 
> it, and when to dispense with it when it's being used for things that areck not in 
> my interest.
> 

You're apparently not doing that now, why will you do that later?

You're not being forced to do anything, are you? You could use HTTP 1.1
forever, right? Oh right, sometimes choice is removed! How does it feel
to be like the rest of the world for just one moment?

Sincerely,
Jacob

---

From: Stephen Farrell <[email-masked]>
Date: Sat, 07 Dec 2013 13:14:05 +0000

Bruce,

On 12/07/2013 07:29 AM, Bruce Perens wrote:
>> If the attacker can see your fetches he can execute a
>> man-on-the-side attack through packet injection.
> This is the first one I've seen that is actually compelling.

I agree that Nicholas' posting is compelling. It really is.

I also agree that a bunch of the non-technical analogy-driven
stuff is not at all compelling.

But one compelling argument is enough really.

> But it's an . authentication problem rather than a confidentiality
> one.

I don't think so. The lack of confidentiality lets the
adversary win the race unless you assume 100% coverage
of authenticated JS and 100% validation of that and that
there are no diginotar like entities involved in the
currently non-existent JS authentication infrastructure.

Even ignoring the race condition, it'd only be reasonable
to treat this as an authentication-only problem if there was
a solution for the JS authentication problem.

Today, there's no such solution for how to load JS with
integrity but without TLS after an https:// "landing page"
load. I've thought about ways to do it with RFC 6920, but
so far without finding a way that could scale or would be
likely to get adopted - apparently the JS code gets
updated too often for a 6920 based approach to help very
much.

So, while authenticated-JS is also a fine problem on which
to work, today we have tooling for addressing the problem
via ubiquitous TLS but we do not have the kind of tooling
that would be needed for a solution that does not provide
confidentiality.

Even if we only did opportunistic encryption then an
observatory could spot a pervasive attack against that, or
against that for Air France to use the example cited. (Air
France might be motivated to want such an observatory to
exist for example.)

Separately, if one considers the long-tail bits of JS code
loaded from the long-tail set of web sites then again there
is some benefit in confidentiality since without that the
adversary can pervasively find the vulnerable code and sites
from those. The "long-tail" here is relevant because we
should assume the adversary knows the vulnerabilities for the
top-10^N sites and JS packages. I think any IETF approach
to this kind of thing should not give a high preference to
the top-10^N anything really, which again argues for doing
this based on TLS or similar I think.

So what I see is a compelling problem-statement, and an
existing set of tools that can address that if more widely
deployed, and where confidentiality is in reality an inherent
part of doing that.

Cheers,
S.

---

From: Nicholas Weaver <[email-masked]>
Date: Sat, 7 Dec 2013 07:48:02 -0800

> updated too often for a 6920 based approach to help very

We do actually have a system for data integrity without confidentiality.  Its called DNSSEC.  And the lack of confidentiality is a deliberate design decision due to its focus around offline signature generation and a structure composed of various proven untrustworthy intermediaries.

So if you really actually WANTED data integrity on elements (and it has to be all HTML, CSS, JS, flash, etc.. since all of those are directly executable content, so you might as well do ALL elements.  After all, there have been image rendering vulnerabilities too..), how about storing them and just fetching them through DNSSEC...

Indeed, thats a very silly and downright stupid idea.  Nobody will do it.

Why?  Because our model for HTTP is that content is often generated dynamically, so each dynamic element would need to be signed dynamically, so instead our focus on HTTP is on channel security: create a secure channel and then keep using it.

There is effectively zero call for "MAC w/o ENCRYPT", which is whats necessary to answer "authentication problem rather than a confidentiality one." in terms of channel security.  We don't do it.   Why?  Because its stupid.  You'd still need to go through all the public key certificate efforts, key exchange, server side computation, and all the other crap needed for a TLS handshake or similar to generate a MAC key.  Adding in encryption is a practical no-op by this point.

And without doing a key exchange for a MAC and instead doing signatures for integrity, signature verification happens at the END of a communication.  Signatures are expensive to generate and validate (and verification w/o a key exchange requires a lot more of them anyway), so you'd hash all the data and then sign/verify, so you coludn't take advantage of incremental rendering, lest you render an iframe at the start that shouldn't be there.

Yes, you could use some block-hash structure where at the start you get a signature over a bunch of block hashes, but that instead requires that the sender know in advance the WHOLE message.  Its a silly thought, since the server in many cases does NOT know what the full .html document will be when it starts sending it over a TLS channel.

So the idea of "authentication problem rather than a confidentiality one" is a red herring:  We have a solution that solves the authentication problem for HTTP.  Its called TLS.  We MUST use it everywhere, if only to protect US citizens from the French and Chinese, and Russians, and Brazilians, and Israelis...

And a solution which solves authentication w/o confidentiality may be silly, but if you want it anyway, the best solution that gives authentication w/o confidentiality for HTTP is, indeed, a browser button that says:

"F-confidentiality: broadcast my encryption key (but not the MAC key) in the clear if the server consents".

---

From: Hannes Tschofenig <[email-masked]>
Date: Sat, 07 Dec 2013 18:16:00 +0000

The good thing is that Jörg Ziercke is not the only person to decide.

To quote Bruce Schneier:
"
The FBI believes it can have it both ways: that it can open systems to
its eavesdropping, but keep them secure from anyone else’s
eavesdropping. That’s just not possible. It’s impossible to build a
communications system that allows the FBI surreptitious access but
doesn’t allow similar access by others. When it comes to security, we
have two options:
- We can build our systems to be as secure as possible from
eavesdropping, or
- we can deliberately weaken their security.
We have to choose one or the other.
"

Ciao
Hannes

---

From: Phillip Hallam-Baker <[email-masked]>
Date: Sun, 8 Dec 2013 12:33:01 -0500

On Sat, Dec 7, 2013 at 1:16 PM, Hannes Tschofenig <[email-masked]

> We have to choose one or the other.

+1

I have met the senior management of the NSA. My take is that they are
generals fighting the last war. All they understand is attack or threat of
attack as the best form of defense.

Threat of attack does not work against terrorism but it can work against
state sponsors, at least to some degree. Ghadaffi funded many of the
European terrorist organizations, he supplied the IRA with the Semtex
explosive used in the attack on my family. Ghadaffi stopped supplying the
external groups after Reagan's bombing attack on Tripoli but he also downed
two civilian airplanes in retaliation killing hundreds of people.

At this point the traditional terrorist strategy is conspicuously bankrupt.
The terrorists can't gather in sufficient force to be a significant threat
unless they have a state sponsor or a failed state they can operate from.

The new terrorist concern is that there will be a group of hackers with the
sufficient skills and motivation to attack civil critical infrastructure.
Water, electric, etc. And some of the proposals for how to deal with that
threat are worse than the threat. Bombing Iran at the first sign of attack
(which would give Netanyahu an easy way of achieving his objective).
Declaring martial law at the first sign of a critical infrastructure attack.

The last should worry anyone who remembers the Peter Aspinal/James
Goldsmith attempt to organize a coup in the UK. It was a harebrained scheme
but they approached the head of MI5 (who immediately reported the plot to
the PM and the Queen). The US has no shortage of politicians mouthing
treason and they have a whole news infrastructure telling them how right
they are.

So yes, I do worry about terrorism. But I also worry about the people in
charge of this surveillance infrastructure being the threat. I certainly do
not think we can trust people who spend their time telling each other fairy
stories about the President being illegitimate because he is not a US
citizen.

---

From: <[email-masked]>
Date: Sun, 8 Dec 2013 17:41:36 +0000

Really? Is this what this list is for?  If you want to rant about your political views please go elsewhere.  If you want to try to solve a problem, we are all ears.  This is not about one government or another doing something bad since all governments do it. Some are just better at it today. Others will catch up if we don't do something it. Regardless we need to address the problem not just post to see ourselves post…  Or maybe I totally misunderstood the reason for this list.

From: Phillip Hallam-Baker <[email-masked]<mailto:[email-masked]>>
Date: Sunday, December 8, 2013 11:33 AM
To: Hannes Tschofenig <[email-masked]<mailto:[email-masked]>>
Cc: SM <[email-masked]<mailto:[email-masked]>>, perpass <[email-masked]<mailto:[email-masked]>>, Bruce Perens <[email-masked]<mailto:[email-masked]>>, Pranesh Prakash <[email-masked]<mailto:[email-masked]>>, Andreas Kuckartz <[email-masked]<mailto:[email-masked]>>
Subject: Re: [perpass] Egal wie man diskutiert

On Sat, Dec 7, 2013 at 1:16 PM, Hannes Tschofenig <[email-masked]<mailto:[email-masked]>> wrote:
The good thing is that Jörg Ziercke is not the only person to decide.

To quote Bruce Schneier:
"

+1

I have met the senior management of the NSA. My take is that they are generals fighting the last war. All they understand is attack or threat of attack as the best form of defense.

Threat of attack does not work against terrorism but it can work against state sponsors, at least to some degree. Ghadaffi funded many of the European terrorist organizations, he supplied the IRA with the Semtex explosive used in the attack on my family. Ghadaffi stopped supplying the external groups after Reagan's bombing attack on Tripoli but he also downed two civilian airplanes in retaliation killing hundreds of people.

At this point the traditional terrorist strategy is conspicuously bankrupt. The terrorists can't gather in sufficient force to be a significant threat unless they have a state sponsor or a failed state they can operate from.

The new terrorist concern is that there will be a group of hackers with the sufficient skills and motivation to attack civil critical infrastructure. Water, electric, etc. And some of the proposals for how to deal with that threat are worse than the threat. Bombing Iran at the first sign of attack (which would give Netanyahu an easy way of achieving his objective). Declaring martial law at the first sign of a critical infrastructure attack.

The last should worry anyone who remembers the Peter Aspinal/James Goldsmith attempt to organize a coup in the UK. It was a harebrained scheme but they approached the head of MI5 (who immediately reported the plot to the PM and the Queen). The US has no shortage of politicians mouthing treason and they have a whole news infrastructure telling them how right they are.

So yes, I do worry about terrorism. But I also worry about the people in charge of this surveillance infrastructure being the threat. I certainly do not think we can trust people who spend their time telling each other fairy stories about the President being illegitimate because he is not a US citizen.

---

From: Phillip Hallam-Baker <[email-masked]>
Date: Sun, 8 Dec 2013 13:09:01 -0500

On Sun, Dec 8, 2013 at 12:41 PM, <[email-masked]> wrote:

>  Really? Is this what this list is for?  If you want to rant about your
> political views please go elsewhere.  If you want to try to solve a
> problem, we are all ears.  This is not about one government or another
> doing something bad since all governments do it. Some are just better at it
> today. Others will catch up if we don't do something it. Regardless we need
> to address the problem not just post to see ourselves post…  Or maybe I
> totally misunderstood the reason for this list.
>

I was responding to yet another poster suggesting that we should do
nothing. If people want to argue about whether we should be doing this work
then we are arguing politics, end of story.

I have met the people and those are my personal opinions of their
trustworthiness. Nor was I the only person to come to that conclusion.

What I have suspected for some time is that our generals, the Chinese
generals and the Russian generals would all rather like to have a cyber
arms race and get the rest of us to all foot the bill for it.

---

From: Robin Wilton <[email-masked]>
Date: Sun, 8 Dec 2013 19:59:31 +0000

Nick, 

I agree that there is a cost threshold for signature/MAC. It is something I uncovered in my PKI research: for PKI-enabled micropayments it is, arguably, not worth signing the public key involved, if the number of disputed payments is at normal levels... because normal levels, for most micropayment applications, are low. It's more cost-effective to simply refund the tiny minority of disputed payments.

That said, I think what we learned from IETF88 was that the strategy most likely to succeed against pervasive, unaccountable state interception is to make it more costly for the net reception to take place. (Essentially, forcing accountability by forcing expenditure). 

We have also seen evidence of large-scale MITM attacks, made easier by the weakness of integrity mechanisms in session establishment and key exchange.

If that's the new context in which we find ourselves architecting systems, then it may change the calculation that says "Integrity checks aren't worth paying for".

NB - I am not saying that this necessarily justifies breaking all web traffic down to frames and applying MACs/DSigs at the element level; all I'm saying is that the events of 2013 change the cost structure of integrity mechanisms, and we should adjust our architectural principles accordingly.

Yrs.,
Robin

Robin Wilton

Technical Outreach Director - Identity and Privacy

On 7 Dec 2013, at 15:48, Nicholas Weaver <[email-masked]> wrote:
be

---

From: Robin Wilton <[email-masked]>
Date: Sun, 8 Dec 2013 20:16:32 +0000

The point about the "nothing to hide" fallacy, as others better qualified than me have pointed out, is not that people might not care if their static images, CSS and JavaScript are loaded in clear, but the fact that in a "nothing to hide, nothing to fear" society, the individual does not get to choose what is "acceptable" and what leads to chilling effects, curtailment of liberties, or even punitive sanctions.

Daniel Solove has written persuasively about the pernicious harms of NTHNTF, but he is "just" a trailblazer. We should never lose sight of the fact that we are in the infancy of understanding the effects of Total Informational Awareness on social norms, social behaviour, and social outcomes. I think we should have the level-headedness to acknowledge that, when it has occurred in the past, in pre-digital societies, massive informational awareness has, more often than not, been abused, with harmful social consequences.

R

Robin Wilton

---

From: Albert Lunde <[email-masked]>
Date: Sun, 08 Dec 2013 18:24:12 -0600

On 12/8/2013 1:59 PM, Robin Wilton wrote:
> Nick,
> >
> I agree that there is a cost threshold for signature/MAC. It is
> something I uncovered in my PKI research: for PKI-enabled micropayments
> it is, arguably, not worth signing the public key involved, if the
> number of disputed payments is at normal levels... because normal
> levels, for most micropayment applications, are low. It's more
> cost-effective to simply refund the tiny minority of disputed payments.

It seems like a threat model that assumes the sole risk is disputed 
payments "at the normal rate" is broken in the presence of automated 
attacks.

I don't think the NSA is the only bad actor, in the short term, 
for-profit criminal groups seem more likely to do active or tailored 
attacks.  This can result in bursts of fraud and/or malware affecting 
particular clients or sites disproportionately.

---

From: Robin Wilton <[email-masked]>
Date: Mon, 9 Dec 2013 09:38:11 +0100

Thanks Albert - 

Right... but I'm not excluding cases where micropayment systems are subjected to automated attack; I'm suggesting that that would represent 'abnormal' levels of disputed payment. I was considering integrity protection (MAC/signing) in the context of disputed micropayments at 'normal' (i.e. personal, non-automated) volumes. 
I think the countermeasures for that threat model differ from the countermeasures for automated attack.

I hope this helps clarify the point I was trying to make.

R

Robin Wilton
Internet Society

email: [email-masked]
Phone: +44 705 005 2931
Twitter: @futureidentity

On 9 Dec 2013, at 01:24, Albert Lunde wrote:

> It seems like a threat model that assumes the sole risk is disputed payments "at the normal rate" is broken in the presence of automated attacks.
> 
> I don't think the NSA is the only bad actor, in the short term, for-profit criminal groups seem more likely to do active or tailored attacks.  This can result in bursts of fraud and/or malware affecting particular clients or sites disproportionately.
>

---

From: Dave Crocker <[email-masked]>
Date: Wed, 18 Dec 2013 11:11:42 -0800

On 12/7/2013 7:48 AM, Nicholas Weaver wrote:
> We do actually have a system for data integrity without confidentiality.  Its called DNSSEC.

Although 10 days later and just to get this into the record:

    It's also called DKIM.

d/

-- 
Dave Crocker
Brandenburg InternetWorking
bbiw.net

---

From: Richard Barnes <[email-masked]>
Date: Wed, 18 Dec 2013 14:50:47 -0500

If we're going go enumerate these, there's also CMS Signed Data, JSON Web
Signature, TLS_RSA_WITH_NULL_SHA256, etc., etc.

I don't think that's really the point of the discussion, though.

--Richard

---

From: Dave Crocker <[email-masked]>
Date: Thu, 26 Dec 2013 17:15:03 -0800

On 12/7/2013 7:48 AM, Nicholas Weaver wrote:
> So the idea of "authentication problem rather than a confidentiality
> one" is a red herring:  We have a solution that solves the
> authentication problem for HTTP.  Its called TLS.  We MUST use it
> everywhere, if only to protect US citizens from the French and
> Chinese, and Russians, and Brazilians, and Israelis...

Except that it solves only a narrow case of authentication.

It's a hop-by-hop solution and mostly authenticates the server, rather 
than the data the server is feeding the client.  For the data the server 
truly is creating, that's probably ok.  For data it's merely relaying, 
on behalf of the actual author, it's probably not.

So while, yes, authenticating the content is more hassle, it's also more 
meaningful.

And therefore, contrary to Richard's assessment, I think the question of 
widely-used content-based authentication mechanisms is relevant, 
specifically because it demonstrates the viability of actual, end-to-end 
identification, rather than hop-by-hop (and therefore 
within-relay-exposed) channel-based approaches.  The question then is 
not what mechanisms exist, but what mechanisms are actually in 
widespread use.

d/

---

From: Bruce Perens <[email-masked]>
Date: Thu, 26 Dec 2013 23:48:43 -0800

eTag is a partial step in this direction. But not very far. There's no defined way for the client to independently verify it, and it isn't necessarily identical across different lossless compressions of the object. A tighter specification could add end-to-end authentication of an object while retaining the existing functions of eTag.

The most oft-used convention is a separate checksum file. Less often, the checksum file is signed.
-- 
Sent from my Android phone with K-9 Mail. Please excuse my brevity.